package com.sun.messaging.jmq.jmsserver.data;

import java.io.IOException;

import com.sun.messaging.jmq.jmsserver.util.BrokerException;

public class TransactionWorkFactory {
	
	
	public static final byte LOCAL_TRANSACTION_WORK_TYPE = 1;
	public static final byte CLUSTER_TRANSACTION_WORK_TYPE = 2;
	public static final byte REMOTE_TRANSACTION_WORK_TYPE = 3;
	
	
	static public BaseTransaction readFromBytes(byte[] data) throws IOException,BrokerException
	{
		
		BaseTransaction result = null;
		byte type = data[0];
		result = create(type);
		result.readFromBytes(data);						
		return result;		
	}
	
	static BaseTransaction create(byte type) {
		BaseTransaction result = null;
		switch (type) {
		case LOCAL_TRANSACTION_WORK_TYPE:
			result = new LocalTransaction();
			break;
		case CLUSTER_TRANSACTION_WORK_TYPE:
			result = new ClusterTransaction();
			break;
		case REMOTE_TRANSACTION_WORK_TYPE:
			result = new RemoteTransaction();
			break;
		}
		return result;
	}

}
